"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var architect_1 = require("@angular-devkit/architect");
var core_1 = require("@angular-devkit/core");
var fs_1 = require("fs");
var merge_1 = require("xliff-simple-merge/dist/src/merge");
var xmlNormalize_1 = require("xml_normalize/dist/src/xmlNormalize");
exports.default = (0, architect_1.createBuilder)(copyFileBuilder);
function copyFileBuilder(options, context) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function () {
        var extractI18nTarget, extractI18nOptions, outputPath, format, isXliffV2, extractI18nRun, extractI18nResult, sourcePath, translationSourceFile, removePaths, normalizeWhitespace, normalizedTranslationSourceFile, _i, _d, targetFile, targetPath, translationTargetFile, mergedTarget, normalizedTarget;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    context.logger.info("Running ng-extract-i18n-merge^1.0.2 for project ".concat((_a = context.target) === null || _a === void 0 ? void 0 : _a.project, "."));
                    console.debug = function () { return null; }; // prevent debug output from xml_normalize and xliff-simple-merge
                    extractI18nTarget = { target: 'extract-i18n', project: (_b = context.target) === null || _b === void 0 ? void 0 : _b.project };
                    return [4 /*yield*/, context.getTargetOptions(extractI18nTarget)];
                case 1:
                    extractI18nOptions = _e.sent();
                    context.logger.info("options: ".concat(JSON.stringify(options)));
                    context.logger.info("extractI18nOptions: ".concat(JSON.stringify(extractI18nOptions)));
                    outputPath = options.outputPath || extractI18nOptions.outputPath || '.';
                    format = options.format || extractI18nOptions.format || 'xlf';
                    isXliffV2 = format.includes('2');
                    context.logger.info('running "extract-i18n" ...');
                    return [4 /*yield*/, context.scheduleTarget(extractI18nTarget, { outputPath: outputPath, format: format, progress: false })];
                case 2:
                    extractI18nRun = _e.sent();
                    return [4 /*yield*/, extractI18nRun.result];
                case 3:
                    extractI18nResult = _e.sent();
                    if (!extractI18nResult.success) {
                        return [2 /*return*/, { success: false, error: "\"extract-i18n\" failed: ".concat(extractI18nResult.error) }];
                    }
                    context.logger.info("extracted translations successfully");
                    sourcePath = (0, core_1.join)((0, core_1.normalize)(outputPath), 'messages.xlf');
                    context.logger.info("normalize ".concat(sourcePath, " ..."));
                    return [4 /*yield*/, fs_1.promises.readFile(sourcePath, 'utf8')];
                case 4:
                    translationSourceFile = _e.sent();
                    removePaths = __spreadArray(__spreadArray([], (options.includeContext ? [] : [isXliffV2 ? '/xliff/file/unit/notes' : '/xliff/file/body/trans-unit/context-group']), true), ((_c = options.removeIdsWithPrefix) !== null && _c !== void 0 ? _c : []).map(function (removePrefix) { return isXliffV2 ? "/xliff/file/unit[starts-with(@id,\"".concat(removePrefix, "\")]") : "/xliff/file/body/trans-unit[starts-with(@id,\"".concat(removePrefix, "\")]"); }), true);
                    normalizeWhitespace = extractI18nOptions.collapseWhitespace === true;
                    normalizedTranslationSourceFile = (0, xmlNormalize_1.xmlNormalize)({
                        in: translationSourceFile,
                        trim: false,
                        attributeTrim: false,
                        normalizeWhitespace: false,
                        sortPath: isXliffV2 ? '/xliff/file/unit/@id' : '/xliff/file/body/trans-unit/@id',
                        removePath: removePaths
                    });
                    return [4 /*yield*/, fs_1.promises.writeFile(sourcePath, normalizedTranslationSourceFile)];
                case 5:
                    _e.sent();
                    _i = 0, _d = options.targetFiles;
                    _e.label = 6;
                case 6:
                    if (!(_i < _d.length)) return [3 /*break*/, 10];
                    targetFile = _d[_i];
                    targetPath = (0, core_1.join)((0, core_1.normalize)(outputPath), targetFile);
                    context.logger.info("merge and normalize ".concat(targetPath, " ..."));
                    return [4 /*yield*/, fs_1.promises.readFile(targetPath, 'utf8')];
                case 7:
                    translationTargetFile = _e.sent();
                    mergedTarget = (0, merge_1.merge)(normalizedTranslationSourceFile, translationTargetFile, options);
                    normalizedTarget = (0, xmlNormalize_1.xmlNormalize)({
                        in: mergedTarget,
                        trim: false,
                        attributeTrim: false,
                        normalizeWhitespace: false,
                        sortPath: isXliffV2 ? '/xliff/file/unit/@id' : '/xliff/file/body/trans-unit/@id',
                        removePath: removePaths
                    });
                    return [4 /*yield*/, fs_1.promises.writeFile(targetPath, normalizedTarget)];
                case 8:
                    _e.sent();
                    _e.label = 9;
                case 9:
                    _i++;
                    return [3 /*break*/, 6];
                case 10:
                    context.logger.info('finished i18n merging and normalizing');
                    return [2 /*return*/, { success: true }];
            }
        });
    });
}
