"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var architect_1 = require("@angular-devkit/architect");
var testing_1 = require("@angular-devkit/architect/testing");
var core_1 = require("@angular-devkit/core");
var fs_1 = require("fs");
var builder_1 = __importDefault(require("./builder"));
describe('Builder', function () {
    var architect;
    var architectHost;
    beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
        var registry;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    registry = new core_1.schema.CoreSchemaRegistry();
                    registry.addPostTransform(core_1.schema.transforms.addUndefinedDefaults);
                    // TestingArchitectHost() takes workspace and current directories.
                    // Since we don't use those, both are the same in this case.
                    architectHost = new testing_1.TestingArchitectHost(__dirname, __dirname);
                    architect = new architect_1.Architect(architectHost, registry);
                    // This will either take a Node package name, or a path to the directory
                    // for the package.json file.
                    // await architectHost.addBuilderFromPackage('..');
                    return [4 /*yield*/, architectHost.addBuilder('ng-extract-i18n-merge:ng-extract-i18n-merge', builder_1.default)];
                case 1:
                    // This will either take a Node package name, or a path to the directory
                    // for the package.json file.
                    // await architectHost.addBuilderFromPackage('..');
                    _a.sent();
                    return [4 /*yield*/, architectHost.addTarget({ project: 'builder-test', target: 'extract-i18n-merge' }, 'ng-extract-i18n-merge:ng-extract-i18n-merge')];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, architectHost.addBuilder('@angular-devkit/build-angular:extract-i18n', (0, architect_1.createBuilder)(function () { return ({ success: true }); }))];
                case 3:
                    _a.sent(); // dummy builder
                    return [4 /*yield*/, architectHost.addTarget({ project: 'builder-test', target: 'extract-i18n' }, '@angular-devkit/build-angular:extract-i18n')];
                case 4:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('should fail if extract-i18n fails', function () { return __awaiter(void 0, void 0, void 0, function () {
        var run, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, architectHost.addBuilder('@angular-devkit/build-angular:extract-i18n', (0, architect_1.createBuilder)(function () { return ({ success: false }); }))];
                case 1:
                    _a.sent(); // dummy builder
                    return [4 /*yield*/, architect.scheduleTarget({ project: 'builder-test', target: 'extract-i18n-merge' }, {
                            format: 'xlf2',
                            targetFiles: ['messages.fr.xlf'],
                            outputPath: 'builder-test',
                        })];
                case 2:
                    run = _a.sent();
                    return [4 /*yield*/, run.result];
                case 3:
                    result = _a.sent();
                    expect(result.success).toBeFalsy();
                    // Stop the builder from running. This stops Architect from keeping
                    // the builder-associated states in memory, since builders keep waiting
                    // to be scheduled.
                    return [4 /*yield*/, run.stop()];
                case 4:
                    // Stop the builder from running. This stops Architect from keeping
                    // the builder-associated states in memory, since builders keep waiting
                    // to be scheduled.
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('extract-and-merge xlf 2.0', function () { return __awaiter(void 0, void 0, void 0, function () {
        var run, result, targetContent;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fs_1.promises.writeFile('builder-test/messages.xlf', '<xliff version="2.0" xmlns="urn:oasis:names:tc:xliff:document:2.0" srcLang="de">\n' +
                        '  <file original="ng.template" id="ngi18n">\n' +
                        '    <unit id="ID1">\n' +
                        '      <segment>\n' +
                        '        <source>source val</source>\n' +
                        '      </segment>\n' +
                        '    </unit>\n' +
                        '    <unit id="ID2">\n' +
                        '      <segment>\n' +
                        '        <source>source val2</source>\n' +
                        '      </segment>\n' +
                        '    </unit>\n' +
                        '    <unit id="removeMeID3">\n' +
                        '      <segment>\n' +
                        '        <source>source val2</source>\n' +
                        '      </segment>\n' +
                        '    </unit>\n' +
                        '  </file>\n' +
                        '</xliff>', 'utf8')];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, fs_1.promises.writeFile('builder-test/messages.fr.xlf', '<xliff version="2.0" xmlns="urn:oasis:names:tc:xliff:document:2.0" srcLang="de">\n' +
                            '  <file original="ng.template" id="ngi18n">\n' +
                            '    <unit id="ID1">\n' +
                            '      <segment>\n' +
                            '        <source>source val</source>\n' +
                            '        <target>target val</target>\n' +
                            '      </segment>\n' +
                            '    </unit>\n' +
                            '  </file>\n' +
                            '</xliff>', 'utf8')];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, architect.scheduleTarget({ project: 'builder-test', target: 'extract-i18n-merge' }, {
                            format: 'xlf2',
                            targetFiles: ['messages.fr.xlf'],
                            outputPath: 'builder-test',
                            removeIdsWithPrefix: ['removeMe']
                        })];
                case 3:
                    run = _a.sent();
                    // The "result" member (of type BuilderOutput) is the next output.
                    return [4 /*yield*/, run.result];
                case 4:
                    // The "result" member (of type BuilderOutput) is the next output.
                    _a.sent();
                    return [4 /*yield*/, run.result];
                case 5:
                    result = _a.sent();
                    expect(result.success).toBeTruthy();
                    // Stop the builder from running. This stops Architect from keeping
                    // the builder-associated states in memory, since builders keep waiting
                    // to be scheduled.
                    return [4 /*yield*/, run.stop()];
                case 6:
                    // Stop the builder from running. This stops Architect from keeping
                    // the builder-associated states in memory, since builders keep waiting
                    // to be scheduled.
                    _a.sent();
                    return [4 /*yield*/, fs_1.promises.readFile('builder-test/messages.fr.xlf', 'utf8')];
                case 7:
                    targetContent = _a.sent();
                    expect(targetContent).toEqual('<xliff version="2.0" xmlns="urn:oasis:names:tc:xliff:document:2.0" srcLang="de">\n' +
                        '  <file original="ng.template" id="ngi18n">\n' +
                        '    <unit id="ID1">\n' +
                        '      <segment>\n' +
                        '        <source>source val</source>\n' +
                        '        <target>target val</target>\n' +
                        '      </segment>\n' +
                        '    </unit>\n' +
                        '    <unit id="ID2">\n' +
                        '      <segment state="initial">\n' +
                        '        <source>source val2</source>\n' +
                        '        <target>source val2</target>\n' +
                        '      </segment>\n' +
                        '    </unit>\n' +
                        '  </file>\n' +
                        '</xliff>');
                    return [2 /*return*/];
            }
        });
    }); });
    test('extract-and-merge xlf 1.2', function () { return __awaiter(void 0, void 0, void 0, function () {
        var run, result, targetContent;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fs_1.promises.writeFile('builder-test/messages.xlf', '<xliff version="1.2" xmlns="urn:oasis:names:tc:xliff:document:1.2">\n' +
                        '  <file source-language="de" datatype="plaintext" original="ng2.template">\n' +
                        '    <body>\n' +
                        '      <trans-unit id="ID1" datatype="html">\n' +
                        '        <source>source val</source>\n' +
                        '      </trans-unit>\n' +
                        '      <trans-unit id="ID2" datatype="html">\n' +
                        '        <source>source val2</source>\n' +
                        '      </trans-unit>\n' +
                        '      <trans-unit id="removeMeID3" datatype="html">\n' +
                        '        <source>source val2</source>\n' +
                        '      </trans-unit>\n' +
                        '    </body>\n' +
                        '  </file>\n' +
                        '</xliff>', 'utf8')];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, fs_1.promises.writeFile('builder-test/messages.fr.xlf', '<xliff version="1.2" xmlns="urn:oasis:names:tc:xliff:document:1.2">\n' +
                            '  <file source-language="de" target-language="fr-ch" datatype="plaintext" original="ng2.template">\n' +
                            '    <body>\n' +
                            '      <trans-unit id="ID1" datatype="html">\n' +
                            '        <source>source val</source>\n' +
                            '        <target state="translated">target val</target>\n' +
                            '      </trans-unit>\n' +
                            '    </body>\n' +
                            '  </file>\n' +
                            '</xliff>', 'utf8')];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, architect.scheduleTarget({ project: 'builder-test', target: 'extract-i18n-merge' }, {
                            format: 'xlf',
                            targetFiles: ['messages.fr.xlf'],
                            outputPath: 'builder-test',
                            removeIdsWithPrefix: ['removeMe']
                        })];
                case 3:
                    run = _a.sent();
                    // The "result" member (of type BuilderOutput) is the next output.
                    return [4 /*yield*/, run.result];
                case 4:
                    // The "result" member (of type BuilderOutput) is the next output.
                    _a.sent();
                    return [4 /*yield*/, run.result];
                case 5:
                    result = _a.sent();
                    expect(result.success).toBeTruthy();
                    // Stop the builder from running. This stops Architect from keeping
                    // the builder-associated states in memory, since builders keep waiting
                    // to be scheduled.
                    return [4 /*yield*/, run.stop()];
                case 6:
                    // Stop the builder from running. This stops Architect from keeping
                    // the builder-associated states in memory, since builders keep waiting
                    // to be scheduled.
                    _a.sent();
                    return [4 /*yield*/, fs_1.promises.readFile('builder-test/messages.fr.xlf', 'utf8')];
                case 7:
                    targetContent = _a.sent();
                    expect(targetContent).toEqual('<xliff version="1.2" xmlns="urn:oasis:names:tc:xliff:document:1.2">\n' +
                        '  <file source-language="de" target-language="fr-ch" datatype="plaintext" original="ng2.template">\n' +
                        '    <body>\n' +
                        '      <trans-unit id="ID1" datatype="html">\n' +
                        '        <source>source val</source>\n' +
                        '        <target state="translated">target val</target>\n' +
                        '      </trans-unit>\n' +
                        '      <trans-unit id="ID2" datatype="html">\n' +
                        '        <source>source val2</source>\n' +
                        '        <target state="new">source val2</target>\n' +
                        '      </trans-unit>\n' +
                        '    </body>\n' +
                        '  </file>\n' +
                        '</xliff>');
                    return [2 /*return*/];
            }
        });
    }); });
});
